<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	boolean isAdmin = false;
	boolean isPatientCurator = false;
	boolean hasCreateSamplePermission = false;
	boolean hasCreateExtractPermission = false;
	try
	{
		Role admin = Role.getById(dc, SystemItems.getId(Role.ADMINISTRATOR));
		isAdmin = sc.isMemberOf(admin);
	}
	catch (RuntimeException ex)
	{}
	try
	{
		ItemQuery<Group> query = Group.getQuery();
		query.restrict(Restrictions.eq(Hql.property("name"), Expressions.string("PatientCurator")));
		List<Group> result = query.list(dc);
		if (result.size() == 1)
		{
			isPatientCurator = sc.isMemberOf(result.get(0));
		}
	}
	catch (RuntimeException ex)
	{}
	try
	{
		if (sc.hasPermission(Permission.CREATE, Item.SAMPLE))
		{
			hasCreateSamplePermission = true;
		}
	}
	catch(RuntimeException ex)
	{}
	try
	{
		if (sc.hasPermission(Permission.CREATE, Item.EXTRACT))
		{
			hasCreateExtractPermission = true;
		}
	}
	catch(RuntimeException ex)
	{}
%>
<base:page type="default" >
<base:head styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<%
	if (Application.getMajorVersion() == 3 && Application.getMinorVersion() == 0)
	{
		%>
		<link rel="stylesheet" type="text/css" href="css/base30.css">
		<%
	}
	%>
<style>
dl
{
	margin-top: 0px;
	padding: 3px;
}
dd
{
	margin-left: 0px;
	margin-bottom: 10px;
}
img
{
	vertical-align: text-bottom;
}
h3
{
	color: #333377;
	background: #E8E8E8;
	font-weight: bold;
	margin-bottom: 0em;
	padding: 1px 4px 1px 4px;
	border: 1px solid #A0A0A0;
	font-size: 1em;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement title="Reggie" /></p:path>

	<div class="content">
		<div class="absolutefull" style="width: 50%;">
			<div class="absolutefull" style="left: 1em; right: 0.5em; ">
				<h3>Reggie wizards</h3>
				<dl class="leftborder rightborder bottomborder">
				<%
				if (isAdmin)
				{
					%>
					<dt>
						<base:icon image="<%=home + "/images/install.png" %>" />
						<a href="install.jsp?ID=<%=ID%>">Installation wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Check that all annotation types and other items used by Reggie exists in BASE.
						<li>Create missing items.
						</ul>
					</dd>
					<%
				}
				if (isPatientCurator || isAdmin)
				{
					%>
					<dt class="topborder" style="padding-top: 0.5em;">
						<base:icon image="<%=home + "/images/personal.png" %>"/>
						<a href="persinfo.jsp?ID=<%=ID%>">Personal information registration wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Register new cases and patients.
						<li>Update existing cases and specimen tubes.
						</ul>
					</dd>
					<%
				}
				if (isPatientCurator || isAdmin)
				{
					%>
					<dt>
						<base:icon image="<%=home + "/images/blood.png" %>"/>
						<a href="bloodform.jsp?ID=<%=ID%>">Blood referral form registration wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Register new blood referral forms and patients.
						<li>Update information for existing blood referral forms.
						</ul>
					</dd>
					<%
				}
				if (isPatientCurator || isAdmin)
				{
					%>
					<dt>
						<base:icon image="<%=home+"/images/consent.png" %>"/>
						<a href="consentform.jsp?ID=<%=ID%>">Consent form registration wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Register consent forms.
						</ul>
					</dd>
					<%
				}
				if (isPatientCurator || isAdmin)
				{
					%>
					<dt>
						<base:icon image="<%=home+"/images/pdffile.png" %>" />
						<a href="refform.jsp?ID=<%=ID%>">Referral form registration wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Link scanned referral forms to cases.
						</ul>
					</dd>
					<%
				}
				if (hasCreateSamplePermission)
				{
					%>
					<dt class="topborder" style="padding-top: 0.5em;">
						<base:icon image="<%=home+"/images/specimen.png" %>" />
						<a href="specimentube.jsp?ID=<%=ID%>">Specimen tube registration wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Register new specimen tubes.
						<li>Update existing specimen tubes.
						</ul>
					</dd>
					<%
				}
				if (hasCreateSamplePermission && hasCreateExtractPermission)
				{
					%>
					<dt>
						<base:icon image="<%=home+"/images/partition.png" %>" />
						<a href="partitionform.jsp?ID=<%=ID%>">Partition registration wizard</a>
					</dt>
					<dd>
						<ul>
						<li>Register new partitions of existing specimens.
						</ul>
					</dd>
					<%
				}
				if (hasCreateExtractPermission)
				{
					%>
					<dt>
						<base:icon image="<%=home+"/images/rnaqc.png" %>" />
						RNA quality control wizards
					</dt>
					<dd>
						<ul>
						<li><a href="rnaqc_aliquot.jsp?ID=<%=ID%>">Create aliquots on Bioanalyzer/Caliper plates</a>
						<li><a href="rnaqc_plate_export.jsp?ID=<%=ID%>">Export Caliper sample names and run parameters</a>
						<li><a href="rnaqc_plate_import.jsp?ID=<%=ID%>">Import RQS scores from Caliper well table file</a>
						</ul>
					</dd>
					<%
				}
				%>				
				</dl>
			</div>
		</div>
		
		<div class="absolutefull" style="width: 50%; left: auto;">
			<div class="absolutefull" style="left: 0.5em; right: 1em;">
				<h3>Reggie reports</h3>
				<dl class="leftborder rightborder bottomborder">
					<dt>
						<base:icon image="<%=home+"/images/report.png" %>" />
						<a href="samplereportgenerator.jsp?ID=<%=ID%>">Report generator</a>
					</dt>				
					<dd>				
						<ul>
						<li>Sample count report</li> 
						</ul>
					</dd>
				</dl>
			
			</div>
		</div>

	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>